| Cantera 3.0.0

Loading...
Searching...
No Matches
Public Member Functions | Protected Attributes | List of all members
NasaPoly2 Class Reference
Thermodynamic Properties » Species Reference-State Thermodynamic Properties

The NASA polynomial parameterization for two temperature ranges. More...

`#include <NasaPoly2.h>`

Inheritance diagram for NasaPoly2:
[legend]

## Detailed Description

The NASA polynomial parameterization for two temperature ranges.

This parameterization expresses the heat capacity as a fourth-order polynomial. Note that this is the form used in the 1971 NASA equilibrium program and by the Chemkin software package, but differs from the form used in the more recent NASA equilibrium program.

Seven coefficients \( (a_0,\dots,a_6) \) are used to represent \( c_p^0(T) \), \( h^0(T) \), and \( s^0(T) \) as polynomials in \( T \) :

\[ \frac{c_p(T)}{R} = a_0 + a_1 T + a_2 T^2 + a_3 T^3 + a_4 T^4 \]

\[ \frac{h^0(T)}{RT} = a_0 + \frac{a_1}{2} T + \frac{a_2}{3} T^2 + \frac{a_3}{4} T^3 + \frac{a_4}{5} T^4 + \frac{a_5}{T}. \]

\[ \frac{s^0(T)}{R} = a_0\ln T + a_1 T + \frac{a_2}{2} T^2 + \frac{a_3}{3} T^3 + \frac{a_4}{4} T^4 + a_6. \]

This class is designed specifically for use by the class MultiSpeciesThermo.

Definition at line 48 of file NasaPoly2.h.

## Public Member Functions
| NasaPoly2 (double tlow, double thigh, double pref, const double *coeffs)
| Constructor with all input data.
void | setMinTemp (double Tmin) override
| Set the minimum temperature at which the thermo parameterization is valid.
void | setMaxTemp (double Tmax) override
| Set the maximum temperature at which the thermo parameterization is valid.
void | setRefPressure (double Pref) override
| Set the reference pressure [Pa].
void | setParameters (double Tmid, const vector< double > &low, const vector< double > &high)
int | reportType () const override
| Returns an integer representing the type of parameterization.
size_t | temperaturePolySize () const override
| Number of terms in the temperature polynomial for this parameterization.
void | updateTemperaturePoly (double T, double *T_poly) const override
| Given the temperature T, compute the terms of the temperature polynomial T_poly.
void | updateProperties (const double *tt, double *cp_R, double *h_RT, double *s_R) const override
| Update the properties for this species, given a temperature polynomial.
void | updatePropertiesTemp (const double temp, double *cp_R, double *h_RT, double *s_R) const override
| Compute the reference-state property of one species.
size_t | nCoeffs () const override
| This utility function returns the number of coefficients for a given type of species parameterization.
void | reportParameters (size_t &n, int &type, double &tlow, double &thigh, double &pref, double *const coeffs) const override
| This utility function returns the type of parameterization and all of the parameters for the species.
void | getParameters (AnyMap &thermo) const override
| Store the parameters of the species thermo object such that an identical species thermo object could be reconstructed using the newSpeciesThermo() function.
double | reportHf298 (double *const h298=nullptr) const override
| Report the 298 K Heat of Formation of the standard state of one species (J kmol-1)
void | resetHf298 () override
| Restore the original heat of formation for this species.
void | modifyOneHf298 (const size_t k, const double Hf298New) override
| Modify the value of the 298 K Heat of Formation of one species in the phase (J kmol-1)
void | validate (const string &name) override
| Check for problems with the parameterization, and generate warnings or throw and exception if any are found.
Public Member Functions inherited from SpeciesThermoInterpType
| SpeciesThermoInterpType (double tlow, double thigh, double pref)
| SpeciesThermoInterpType (const SpeciesThermoInterpType &b)=delete
SpeciesThermoInterpType & | operator= (const SpeciesThermoInterpType &b)=delete
virtual double | minTemp () const
| Returns the minimum temperature that the thermo parameterization is valid.
virtual double | maxTemp () const
| Returns the maximum temperature that the thermo parameterization is valid.
virtual double | refPressure () const
| Returns the reference pressure (Pa)
AnyMap | parameters (bool withInput=true) const
| Return the parameters of the species thermo object such that an identical species thermo object could be reconstructed using the newSpeciesThermo() function.
const AnyMap & | input () const
| Access input data associated with the species thermo definition.
AnyMap & | input ()

## Protected Attributes
double | m_midT = 0.0
| Midrange temperature.
NasaPoly1 | mnp_low
| NasaPoly1 object for the low temperature region.
NasaPoly1 | mnp_high
| NasaPoly1 object for the high temperature region.
Protected Attributes inherited from SpeciesThermoInterpType
double | m_lowT = 0.0
| lowest valid temperature
double | m_highT = 0.0
| Highest valid temperature.
double | m_Pref = 0.0
| Reference state pressure.
AnyMap | m_input

## Additional Inherited Members

## Constructor & Destructor Documentation

## ◆ NasaPoly2()

NasaPoly2 | ( | double | tlow,
|  | double | thigh,
|  | double | pref,
|  | const double * | coeffs
| ) |  |
| inline

Constructor with all input data.

Parameters

  tlow | output - Minimum temperature
  thigh | output - Maximum temperature
  pref | output - reference pressure (Pa).
  coeffs | Vector of coefficients used to set the parameters for the standard state [Tmid, 7 high-T coeffs, 7 low-T coeffs]. This is the coefficient order used in the standard NASA format.

Definition at line 63 of file NasaPoly2.h.

## Member Function Documentation

## ◆ setMinTemp()

void setMinTemp | ( | double | Tmin | ) |
| inline override virtual

Set the minimum temperature at which the thermo parameterization is valid.

Reimplemented from SpeciesThermoInterpType.

Definition at line 70 of file NasaPoly2.h.

## ◆ setMaxTemp()

void setMaxTemp | ( | double | Tmax | ) |
| inline override virtual

Set the maximum temperature at which the thermo parameterization is valid.

Reimplemented from SpeciesThermoInterpType.

Definition at line 75 of file NasaPoly2.h.

## ◆ setRefPressure()

void setRefPressure | ( | double | Pref | ) |
| inline override virtual

Set the reference pressure [Pa].

Reimplemented from SpeciesThermoInterpType.

Definition at line 80 of file NasaPoly2.h.

## ◆ setParameters()

void setParameters | ( | double | Tmid,
|  | const vector< double > & | low,
|  | const vector< double > & | high
| ) |  |

Parameters

  Tmid | Temperature [K] at the boundary between the low and high temperature polynomials
  low | Vector of 7 coefficients for the low temperature polynomial
  high | Vector of 7 coefficients for the high temperature polynomial

Definition at line 11 of file NasaPoly2.cpp.

## ◆ reportType()

int reportType | ( |  | ) | const
| inline override virtual

Returns an integer representing the type of parameterization.

Reimplemented from SpeciesThermoInterpType.

Definition at line 94 of file NasaPoly2.h.

## ◆ temperaturePolySize()

size_t temperaturePolySize | ( |  | ) | const
| inline override virtual

Number of terms in the temperature polynomial for this parameterization.

Reimplemented from SpeciesThermoInterpType.

Definition at line 98 of file NasaPoly2.h.

## ◆ updateTemperaturePoly()

void updateTemperaturePoly | ( | double | T,
|  | double * | T_poly
| ) |  | const
| inline override virtual

Given the temperature T, compute the terms of the temperature polynomial T_poly.

Reimplemented from SpeciesThermoInterpType.

Definition at line 100 of file NasaPoly2.h.

## ◆ updateProperties()

void updateProperties | ( | const double * | tt,
|  | double * | cp_R,
|  | double * | h_RT,
|  | double * | s_R
| ) |  | const
| inline override virtual

Update the properties for this species, given a temperature polynomial.

This method is called with a pointer to an array containing the functions of temperature needed by this parameterization, and three pointers to arrays where the computed property values should be written. This method updates only one value in each array.

The form and length of the Temperature Polynomial may vary depending on the parameterization.

Parameters

  tt | vector of evaluated temperature functions
  cp_R | Vector of Dimensionless heat capacities. (length m_kk).
  h_RT | Vector of Dimensionless enthalpies. (length m_kk).
  s_R | Vector of Dimensionless entropies. (length m_kk).

Temperature Polynomial: tt[0] = t; tt[1] = t*t; tt[2] = m_t[1]*t; tt[3] = m_t[2]*t; tt[4] = 1.0/t; tt[5] = std::log(t);

Reimplemented from SpeciesThermoInterpType.

Definition at line 105 of file NasaPoly2.h.

## ◆ updatePropertiesTemp()

void updatePropertiesTemp | ( | const double | temp,
|  | double * | cp_R,
|  | double * | h_RT,
|  | double * | s_R
| ) |  | const
| inline override virtual

Compute the reference-state property of one species.

Given temperature T in K, this method updates the values of the non- dimensional heat capacity at constant pressure, enthalpy, and entropy, at the reference pressure, of the species.

Parameters

  temp | Temperature (Kelvin)
  cp_R | Vector of Dimensionless heat capacities. (length m_kk).
  h_RT | Vector of Dimensionless enthalpies. (length m_kk).
  s_R | Vector of Dimensionless entropies. (length m_kk).

Reimplemented from SpeciesThermoInterpType.

Definition at line 114 of file NasaPoly2.h.

## ◆ nCoeffs()

size_t nCoeffs | ( |  | ) | const
| inline override virtual

This utility function returns the number of coefficients for a given type of species parameterization.

Reimplemented from SpeciesThermoInterpType.

Definition at line 123 of file NasaPoly2.h.

## ◆ reportParameters()

void reportParameters | ( | size_t & | index,
|  | int & | type,
|  | double & | minTemp,
|  | double & | maxTemp,
|  | double & | refPressure,
|  | double *const | coeffs
| ) |  | const
| inline override virtual

This utility function returns the type of parameterization and all of the parameters for the species.

All parameters are output variables

Parameters

  index | Species index
  type | Integer type of the standard type
  minTemp | output - Minimum temperature
  maxTemp | output - Maximum temperature
  refPressure | output - reference pressure (Pa).
  coeffs | Vector of coefficients used to set the parameters for the standard state.

Reimplemented from SpeciesThermoInterpType.

Definition at line 125 of file NasaPoly2.h.

## ◆ getParameters()

void getParameters | ( | AnyMap & | thermo | ) | const
| override virtual

Store the parameters of the species thermo object such that an identical species thermo object could be reconstructed using the newSpeciesThermo() function.

Reimplemented from SpeciesThermoInterpType.

Definition at line 20 of file NasaPoly2.cpp.

## ◆ reportHf298()

double reportHf298 | ( | double *const | h298 = `nullptr` | ) | const
| inline override virtual

Report the 298 K Heat of Formation of the standard state of one species (J kmol-1)

The 298K Heat of Formation is defined as the enthalpy change to create the standard state of the species from its constituent elements in their standard states at 298 K and 1 bar.

Parameters

  h298 | If this is nonnull, the current value of the Heat of Formation at 298K and 1 bar for species m_speciesIndex is returned in h298[m_speciesIndex].

Returns
  the current value of the Heat of Formation at 298K and 1 bar for species m_speciesIndex.

Reimplemented from SpeciesThermoInterpType.

Definition at line 134 of file NasaPoly2.h.

## ◆ resetHf298()

void resetHf298 | ( |  | ) |
| inline override virtual

Restore the original heat of formation for this species.

Resets changes made by modifyOneHf298().

Reimplemented from SpeciesThermoInterpType.

Definition at line 147 of file NasaPoly2.h.

## ◆ modifyOneHf298()

void modifyOneHf298 | ( | const size_t | k,
|  | const double | Hf298New
| ) |  |
| inline override virtual

Modify the value of the 298 K Heat of Formation of one species in the phase (J kmol-1)

The 298K heat of formation is defined as the enthalpy change to create the standard state of the species from its constituent elements in their standard states at 298 K and 1 bar.

Parameters

  k | Species k
  Hf298New | Specify the new value of the Heat of Formation at 298K and 1 bar

Reimplemented from SpeciesThermoInterpType.

Definition at line 152 of file NasaPoly2.h.

## ◆ validate()

void validate | ( | const string & | name | ) |
| override virtual

Check for problems with the parameterization, and generate warnings or throw and exception if any are found.

Reimplemented from SpeciesThermoInterpType.

Definition at line 31 of file NasaPoly2.cpp.

## Member Data Documentation

## ◆ m_midT

double m_midT = 0.0
| protected

Midrange temperature.

Definition at line 167 of file NasaPoly2.h.

## ◆ mnp_low

NasaPoly1 mnp_low
| protected

NasaPoly1 object for the low temperature region.

Definition at line 169 of file NasaPoly2.h.

## ◆ mnp_high

NasaPoly1 mnp_high
| protected

NasaPoly1 object for the high temperature region.

Definition at line 171 of file NasaPoly2.h.

The documentation for this class was generated from the following files:

- NasaPoly2.h
- NasaPoly2.cpp